﻿using System;
using System.Collections.Generic;
using System.Drawing.Printing;
using System.Linq;
using System.Numerics;
using System.Printing;
using System.Runtime.Remoting.Channels;
using System.Text;
using System.Threading.Tasks;
using static PDF_Office.Model.Dialog.HomePageToolsDialogs.HomePagePrinter.HomePagePrinterDialogModel;

namespace PDF_Office.Model.Dialog.HomePageToolsDialogs.HomePagePrinter
{
    public class PrintSettingsInfo
    {
        /// <summary>
        /// 灰度
        /// </summary>
        public bool IsGrayscale { get; set; }
        /// <summary>
        /// 纸张尺寸
        /// </summary>
        public PageMediaSize PageMediaSize;
        /// <summary>
        /// 页码范围
        /// </summary>
        public EnumPageRange EnumPageRange = EnumPageRange.StatusAllRange;
        /// <summary>
        /// 逆页序
        /// </summary>
        public bool IsIndexReverse { get; set; }

        /// <summary>
        /// 双面打印
        /// </summary>
        public bool IsDuplex = false;

        /// <summary>
        /// 是否打印页面边框
        /// </summary>
        public bool IsPrintPageBorde = false;
        /// <summary>
        /// 打印方向
        /// </summary>
        public EnumPrintOrientation EnumPrintOrientation = EnumPrintOrientation.StatusPortrait;
        /// <summary>
        /// 带Annot
        /// </summary>
        public bool IsPrintWithAnnot { get; set; }
        /// <summary>
        /// 带Form
        /// </summary>
        public bool IsPrintWithForm { get; set; }
        /// <summary>
        /// Copies
        /// </summary>
        public int Copies { get; set; }
        /// <summary>
        /// 打印机名称
        /// </summary>
        public string PrinterName { get; set; }
        /// <summary>
        /// 自定义打印页码范围
        /// </summary>
        public List<int> PageRangeList = new List<int>();
        /// <summary>
        /// 打印Mod
        /// </summary>
        public PrintModInfo PrintModInfo  = new SizeInfo();

      public  PrintDocument PrintDocument = new PrintDocument();

        public bool IsBothSides = false;

        public List<int> Margin = new List<int>();

        public PrintSettingsInfo()
        {
            PrintDocument.DefaultPageSettings.Landscape = false;
        }
    }

    public class HomePagePrinterDialogModel
    {

    } 


    public enum EnumSizeType
    {
        StatusAdaptive,
        StatusActural,
        StatusCustomized,
    }

    public enum EnumPageRange
    {
        StatusAllRange,
        StatusOddRange,
        StatusEvenRange,
        StatusCustomizedRange
    }

    public enum EnumPrintOrientation
    {
        StatusPortrait,
        StatusLandscape
    }

    public enum EnumPrintContent
    {
        StatusOnlyDocument,
        StatusDocumentAndMarkUps,
        StatusDocumentAndStamps,
        StatusDocumentAndForm
    }

    public enum EnumPrintMod
    {
        StatusSize,
        StatusPoster,
        StatusMultiple,
        StatusBooklet
    }

    public enum EnumPosterMod
    {
        StatusTile,
        StatusSplit
    }

    public enum EnumDisplayPageNumber
    {
        StatusTwo,
        StatusFour,
        StatusSix,
        StatusNine,
        StatusSixteen,
        StatusCustomized
    }

    public enum EnumPageOrder
    {
        StatusHorizontalOrder,
        StatusHorizontalReverseOrder,
        StatusVerticalOrder,
        StatusVerticalReverseOrder,
    }

    public enum EnumBookletSubset
    {
        StatusBothSides,
        StatusFrontSideOnly,
        StatusBackSideOnly
    }

    public enum EnumBookletBinding
    {
        StatusLeft,
        StatusRight
    }


    public class PrintModInfo
    {
        public EnumPrintMod EnumPrintMod = EnumPrintMod.StatusSize;
    }

    public class SizeInfo : PrintModInfo
    {
        public EnumSizeType EnumSizeType = EnumSizeType.StatusAdaptive;
        public int DisplayRatio = 100;
    }


    public class PosterInfo : PrintModInfo
    {
        public EnumPosterMod EnumPosterMod;
        public bool HasCutMarks { get; set; }
        public bool HasLabel { get; set; }
        public double OverLap { get; set; }
        public EnumDisplayPageNumber EnumDisplayPageNumber { get; set; }
        public int HorizontalSheetNumber { get; set; }
        public int VerticalSheetNumber { get; set; }
        public int TileRatio { get; set; }

        public string Label;

    }

    public class MultipleInfo : PrintModInfo
    {
        public EnumPageOrder EnumPageOrder = EnumPageOrder.StatusHorizontalOrder;
        public EnumDisplayPageNumber EnumDisplayPageNumber = EnumDisplayPageNumber.StatusTwo;
        public int HorizontalPageNumber = 2;
        public int VerticalPageNumber = 1;
        public bool IsAutoRotate  = false;
    }

    public class BookletInfo : PrintModInfo
    {
        public EnumBookletSubset EnumBookletSubset = EnumBookletSubset.StatusBothSides;
        public EnumBookletBinding EnumBookletBinding = EnumBookletBinding.StatusLeft;
        public int BeginPaperIndex = 1;
        public int EndPaperIndex = 1;
        public bool IsAutoRotate = false;
    }
}
