﻿using ComPDFKit.PDFWatermark;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PDF_Office.Model.EditTools.Watermark
{

    public class WatermarkCreateModel
    {
       
    }

    public class WatermarkInfo {

        /// <summary>
        /// 水印类型;
        /// </summary>
        public C_Watermark_Type WatermarkType  = C_Watermark_Type.WATERMARK_TYPE_TEXT;

        /// <summary>
        /// 文本水印内容;
        /// </summary>
        public string Text  = "";

        /// <summary>
        /// 文本水印内容;
        /// </summary>
        public string FontName  = "";

        /// <summary>
        /// 文本水印颜色;
        /// </summary>
        public byte[] TextColor=null;

        /// <summary>
        /// 文本水印大小;
        /// </summary>
        public float TextSize  = 5;

        /// <summary>
        /// 图片水印内容;
        /// </summary>
        public byte[] ImageArray = null;

        /// <summary>
        /// 图片水印路径;
        /// </summary>
        public string ImagePath  = "";

        /// <summary>
        /// 图片水印大小;
        /// </summary>
        public float ImageSize = 5;

        /// <summary>
        /// 图片水印宽度;
        /// </summary>
        public int ImageWidth = 100;

        /// <summary>
        /// 图片水印高度;
        /// </summary>
        public int ImageHeight = 100;

        /// <summary>
        /// 水印页面范围;
        /// </summary>
        public string PageRange  = "0";

        /// <summary>
        /// 水印页面范围索引;
        /// 0:全部页面
        /// 1:奇数页
        /// 2;偶数页
        /// 3:自定义页
        /// </summary>
        public int PageRangeIndex = 0;

        /// <summary>
        /// 水印垂直位置;
        /// </summary>
        public C_Watermark_Vertalign WatermarkVertalign = C_Watermark_Vertalign.WATERMARK_VERTALIGN_CENTER;

        /// <summary>
        /// 水印水平位置;
        /// </summary>
        public C_Watermark_Horizalign WatermarkHorizalign  = C_Watermark_Horizalign.WATERMARK_HORIZALIGN_CENTER;

        /// <summary>
        /// 水印相对垂直距离;
        /// </summary>
        public float VertOffset = 0;

        /// <summary>
        /// 水印相对水平距离;
        /// </summary>
        public float HorizOffset  = 0;

        /// <summary>
        /// 水印石否平铺;
        /// </summary>
        public bool Isfull  = false;

        /// <summary>
        /// 水印平铺水平间距;
        /// </summary>
        public float HorizontalSpacing  = 0;

        /// <summary>
        /// 水印平铺垂直间距;
        /// </summary>
        public float VerticalSpacing  = 0;

        /// <summary>
        /// 水印旋转角度;
        /// </summary>
        public float Rotation = 0;

        /// <summary>
        /// 水印透明度;
        /// </summary>
        public byte Opacity  = 100;

        /// <summary>
        /// 水印是否在页面上方;
        /// </summary>
        public bool IsFront = false;

        /// <summary>
        /// 水印是否自适应比例;
        /// </summary>
        public bool IsRelativeScale = false;

    }
}
