﻿using PDF_Office.Helper;
using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PDF_Office.Model.PDFTool
{
    public class ToolItem : BindableBase
    {
        /// <summary>
        /// 是否为新增的工具
        /// </summary>
        public bool IsNewTool { get; set; }
        /// <summary>
        /// 是否为快捷工具
        /// </summary>
        public bool IsQuickTool { get; set; }
        /// <summary>
        /// 类型：如普通工具、常用工具、付费工具
        /// </summary>
        public int ToolTypeId { get; set; }
        /// <summary>
        /// 类型：如普通工具、常用工具、付费工具
        /// </summary>
        public PDFToolType ToolType { get; set; }
        /// <summary>
        /// 功能名称：拆分功能、合并功能、转档功能等
        /// </summary>
        public PDFFnType FnType { get; set; }

        #region 显示内容

        public string FnImg { get; set; }
        public string FnInfo { get; set; }
        public string FnName { get; set; }

        #endregion
    }
}
