﻿using Prism.Mvvm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;

namespace PDF_Office.ViewModels.Form
{
    public class FormBaseVM : BindableBase
    {
        #region 一般
        //提示
        private string _toolTipStr;
        public string ToolTipStr
        {
            get { return _toolTipStr; }
            set { SetProperty(ref _toolTipStr, value); }
        }
        //名称
        private string _nameStr;
        public string NameStr
        {
            get { return _nameStr; }
            set { SetProperty(ref _nameStr, value); }
        }

        //只读
        public bool _isReadOnly = false;
        public bool IsReadOnly
        {
            get { return _isReadOnly; }
            set { SetProperty(ref _isReadOnly, value); }
        }

        //必填
        public bool _isRequiredField = false;
        public bool IsRequiredField
        {
            get { return _isRequiredField; }
            set { SetProperty(ref _isRequiredField, value); }
        }
        //锁定
        public bool _isLocked = false;
        public bool IsLocked
        {
            get { return _isLocked; }
            set { SetProperty(ref _isLocked, value); }
        }

        #endregion

        #region 外观
        //边框大小
        private double _borderThiness = 0;
        private double BorderThiness
        {
            get { return _borderThiness; }
            set { SetProperty(ref _borderThiness, value); }
        }
        //是否为实线条
        private bool _isSolid = true;
        private bool IsSolid
        {
            get { return _isSolid; }
            set { SetProperty(ref _isSolid, value); }
        }
        //宽大小
        private double _widthSize = 150;
        private double WidthSize
        {
            get { return _widthSize; }
            set { SetProperty(ref _widthSize, value); }
        }
        //高大小
        private double _heightSize = 22;
        private double HeightSize
        {
            get { return _heightSize; }
            set { SetProperty(ref _heightSize, value); }
        }
        //边框颜色
        private Color _borderColor = Colors.Transparent;
        private Color BorderColor
        {
            get { return _borderColor; }
            set { SetProperty(ref _borderColor, value); }
        }
        //内容颜色
        private Color _contentColor = Colors.Transparent;
        private Color ContentColo
        {
            get { return _contentColor; }
            set { SetProperty(ref _contentColor, value); }
        }


        #endregion
    }
}
