﻿using PDF_Office.Model.Dialog.HomePageToolsDialogs.HomePageBatchProcessing;
using PDF_Office.ViewModels.Dialog.HomePageToolsDialogs;
using PDF_Office.ViewModels.Dialog.HomePageToolsDialogs.HomePageBatchProcessing;
using Prism.Ioc;
using Prism.Regions;
using System.Windows.Controls;

namespace PDF_Office.Views.Dialog.HomePageToolsDialogs.HomePageBatchProcessing
{
    /// <summary>
    /// Interaction logic for HomePageBatchProcessingDialog
    /// </summary>
    public partial class HomePageBatchProcessingDialog : UserControl
    {
        private IContainerProvider containerProvider;
        public HomePageBatchProcessingDialog(IContainerProvider containerProvider)
        {
            
            InitializeComponent();
            this.containerProvider = containerProvider;
            var regionManager = containerProvider.Resolve<IRegionManager>();
            RegionManager.SetRegionManager(this, regionManager);
            RegionManager.UpdateRegions();
            SetPathVisibility(HomePageBatchProcessingDialogModel.BatchProcessingIndex);
        }

        public void SetPathVisibility(int index) 
        {
            switch (index)
            {
                case 0:
                    this.ShiftingBtn.IsChecked=true;
                    break;
                case 1:
                    this.CompressBtn.IsChecked = true;
                    break;
                case 2:
                    this.SecurityBtn.IsChecked = true;
                    break;
                case 3:
                    this.WatermarkBtn.IsChecked = true;
                    break;
                case 4:
                    this.BackgroundBtn.IsChecked = true;
                    break;
                case 5:
                    this.HeaderFooterBtn.IsChecked = true;
                    break;
                case 6:
                    this.BatesBtn.IsChecked = true;
                    break;
                case 7:
                    this.RemoveSecurityBtn.IsChecked = true;
                    break;
            }
        }

     

      
    }
}
