﻿using PDF_Office.Helper;
using PDF_Office.Model.Dialog.HomePageToolsDialogs.HomePageBatchProcessing;
using PDF_Office.Model.Dialog.ToolsDialogs.SaftyDialogs;
using PDF_Office.ViewModels.Dialog.HomePageToolsDialogs.HomePageBatchProcessing;
using System;
using System.Collections;
using System.Data;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Interop;

namespace PDF_Office.Views.Dialog.HomePageToolsDialogs.HomePageBatchProcessing
{
    /// <summary>
    /// Interaction logic for HomePageSetPasswordDialog
    /// </summary>
    public partial class HomePageSetPasswordDialog : UserControl
    {
        private HomePageSetPasswordDialogViewModel viewModel;
        private IDropTargetHelper dropHelper;
        private Boolean canOpenPasswordBoxHasFocus = false;
        private Boolean canOpenTextBoxHasFocus = false;

        private Boolean canEditPasswordBoxHasFocus = false;
        private Boolean canEditTextBoxHasFocus = false;

        private string canOpenPasswordBoxName = "CanOpenPasswordBox";
        private string canEditPasswordBoxName = "CanEditPasswordBox";

        private string canOpenTextBoxName = "CanOpenTextBox";
        private string canEditTextBoxName = "CanEditTextBox";

        private string showOpenPasswordBoxEyeLabelName = "ShowOpenPasswordBoxEyeLabel";
        private string showEditPasswordBoxEyeLabelName = "ShowEditPasswordBoxEyeLabel";

        private string showOpenTextBoxEyeLabelName = "ShowOpenTextBoxEyeLabel";
        private string showEditTextBoxEyeLabelName = "ShowEditTextBoxEyeLabel";

        public HomePageSetPasswordDialog()
        {
            InitializeComponent();
            viewModel= this.DataContext as HomePageSetPasswordDialogViewModel;
        }


        private void Menu_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            menuPop1.IsOpen = true;
        }

        private void listView_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            IList list = listView.SelectedItems;
            var lists = listView.Items;
            System.Data.DataRowView a;
            viewModel.fileNamesView.Clear();
            foreach (var item in list)
            {
                a = (System.Data.DataRowView)item;
                viewModel.fileNamesView.Add(lists.IndexOf(a));
            }
            if (viewModel.fileNamesView.Count > 0)
            {
                viewModel.RemoveIsEnable = "True";
            }
            else
            {
                viewModel.RemoveIsEnable = "False";
            }

        }

        private void RemoveFileMenuItem_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            viewModel.removepdffile();
        }

        private void OpenFileMenuItem_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            viewModel.openfiledialog();
        }

        private void PasswordBox_GotFocus(object sender, RoutedEventArgs e)
        {
            var passwordBox = sender as PasswordBox;
            if (passwordBox.Name == canOpenPasswordBoxName)
            {
                canOpenPasswordBoxHasFocus = true;
                canOpenTextBoxHasFocus = false;
            }
            else if (passwordBox.Name == canEditPasswordBoxName)
            {
                canEditPasswordBoxHasFocus = true;
                canEditTextBoxHasFocus = false;
            }
        }

        private void TextBox_GotFocus(object sender, RoutedEventArgs e)
        {
            var textBox = sender as TextBox;
            if (textBox.Name == canOpenTextBoxName)
            {
                canOpenPasswordBoxHasFocus = false;
                canOpenTextBoxHasFocus = true;
            }
            else if (textBox.Name == canEditTextBoxName)
            {
                canEditPasswordBoxHasFocus = false;
                canEditTextBoxHasFocus = true;
            }
        }

        private void PasswordBox_PasswordChanged(object sender, RoutedEventArgs e)
        {
            var passwordBox = sender as PasswordBox;
            if (passwordBox.Name == canOpenPasswordBoxName)
            {
                if (canOpenTextBoxHasFocus)
                {
                    return;
                }
                CanOpenTextBox.Text = CanOpenPasswordBox.Password;
                HomePageSetPasswordDialogModel.PasswordForOpen = CanOpenTextBox.Text;
                viewModel.DelegateCanOpenTextChangedCommand.Execute();
            }
            else if (passwordBox.Name == canEditPasswordBoxName)
            {
                if (canEditTextBoxHasFocus)
                {
                    return;
                }
                CanEditTextBox.Text = CanEditPasswordBox.Password;
                HomePageSetPasswordDialogModel.PasswordForEdit = CanEditTextBox.Text;
                viewModel.DelegateCanOpenTextChangedCommand.Execute();
            }
        }

        private void TextBox_TextChanged(object sender, TextChangedEventArgs e)
        {
            var textBox = sender as TextBox;
            if (textBox.Name == canOpenTextBoxName)
            {
                if (canOpenPasswordBoxHasFocus)
                {
                    return;
                }
                CanOpenPasswordBox.Password = CanOpenTextBox.Text;
                HomePageSetPasswordDialogModel.PasswordForOpen = CanOpenPasswordBox.Password;
                viewModel.DelegateCanOpenTextChangedCommand.Execute();
            }
            else if (textBox.Name == canEditTextBoxName)
            {
                if (canEditPasswordBoxHasFocus)
                { return; }
                CanEditPasswordBox.Password = CanEditTextBox.Text;
                HomePageSetPasswordDialogModel.PasswordForEdit = CanEditPasswordBox.Password;
                viewModel.DelegateCanOpenTextChangedCommand.Execute();
            }
        }

        private void ShowPasswordBoxEyeLabel_MouseLeftButtonUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            var label = sender as Label;
            if (label.Name == showOpenPasswordBoxEyeLabelName)
            {
                CanOpenPasswordBox.Visibility = Visibility.Hidden;
                ShowOpenPasswordBoxEyeLabel.Visibility = Visibility.Hidden;

                CanOpenTextBox.Visibility = Visibility.Visible;
                ShowOpenTextBoxEyeLabel.Visibility = Visibility.Visible;
            }
            else if (label.Name == showEditPasswordBoxEyeLabelName)
            {
                CanEditPasswordBox.Visibility = Visibility.Hidden;
                ShowEditPasswordBoxEyeLabel.Visibility = Visibility.Hidden;

                CanEditTextBox.Visibility = Visibility.Visible;
                ShowEditTextBoxEyeLabel.Visibility = Visibility.Visible;
            }
        }

        private void ShowTextBoxEyeLabel_MouseLeftButtonUp(object sender, System.Windows.Input.MouseButtonEventArgs e)
        {
            var label = sender as Label;
            if (label.Name == showOpenTextBoxEyeLabelName)
            {
                CanOpenPasswordBox.Visibility = Visibility.Visible;
                ShowOpenPasswordBoxEyeLabel.Visibility = Visibility.Visible;

                CanOpenTextBox.Visibility = Visibility.Hidden;
                ShowOpenTextBoxEyeLabel.Visibility = Visibility.Hidden;
            }
            else if (label.Name == showEditTextBoxEyeLabelName)
            {
                CanEditPasswordBox.Visibility = Visibility.Visible;
                ShowEditPasswordBoxEyeLabel.Visibility = Visibility.Visible;

                CanEditTextBox.Visibility = Visibility.Hidden;
                ShowEditTextBoxEyeLabel.Visibility = Visibility.Hidden;
            }
        }
        private void Grid_Drop(object sender, DragEventArgs e)
        {

            try
            {
                Point iconPoint = e.GetPosition(this);
                dropHelper?.Drop((System.Runtime.InteropServices.ComTypes.IDataObject)e.Data, ref iconPoint, e.Effects);
            }
            catch (Exception ex)
            {

            }
            string dropFile = "Drop";
            if (e.Data.GetDataPresent(System.Windows.DataFormats.FileDrop))
            {
                DropGrid.Visibility = Visibility.Collapsed;
                int count = ((System.Array)e.Data.GetData(System.Windows.DataFormats.FileDrop)).Length;
                for (int i = 0; i < count; i++)
                {
                    dropFile = ((System.Array)e.Data.GetData(System.Windows.DataFormats.FileDrop)).GetValue(i).ToString(); ;
                    //MessageBox.Show(dropFile);
                    if (dropFile.ToLower().EndsWith("pdf"))
                    { viewModel.addPDFFiles(dropFile); }
                }
            }
        }
        private void MainPage_DragEnter(object sender, DragEventArgs e)
        {
            DropGrid.Visibility = Visibility.Visible;
            //页面编辑和缩略图
            if ((e.OriginalSource as Image) != null)
                return;
            try
            {
                if (dropHelper == null)
                {
                    dropHelper = Activator.CreateInstance(Type.GetTypeFromCLSID(new Guid("4657278A-411B-11D2-839A-00C04FD918D0"))) as IDropTargetHelper;
                }
                Point iconPoint = e.GetPosition(this);
                dropHelper?.DragEnter(new WindowInteropHelper(Window.GetWindow(this)).Handle, (System.Runtime.InteropServices.ComTypes.IDataObject)e.Data, ref iconPoint, e.Effects);
            }
            catch (Exception ex)
            {

            }

        }

        private void MainPage_DragOver(object sender, DragEventArgs e)
        {

            if ((e.OriginalSource as Image) != null)
                return;
            try
            {
                Point iconPoint = e.GetPosition(this);
                dropHelper?.DragOver(ref iconPoint, e.Effects);
            }
            catch (Exception ex)
            {

            }

        }

        private void MainPage_DragLeave(object sender, DragEventArgs e)
        {
            DropGrid.Visibility = Visibility.Collapsed;
            if ((e.OriginalSource as Image) != null)
                return;
            try
            {
                dropHelper?.DragLeave();
            }
            catch (Exception ex)
            {

            }

        }

        private void DeleteTemplateBtn_Click(object sender, RoutedEventArgs e)
        {
            Button deletetemplatebtn = sender as Button;
            var ls = deletetemplatebtn.DataContext as DataRowView;
            if (ls != null)
            {
                viewModel.removepdffile(viewModel.PDFDataTable.Rows.IndexOf(ls.Row));
            }
        }
    }
}
