﻿using ComPDFKitViewer;
using DryIoc;
using ImTools;
using PDF_Office.Model.Dialog.HomePageToolsDialogs;
using PDF_Office.ViewModels.Dialog.HomePageToolsDialogs;
using PDF_Office.ViewModels.Dialog.HomePageToolsDialogs.HomePageBatchProcessing;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Diagnostics;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;
using System.Xml.Linq;

namespace PDF_Office.Views.Dialog.HomePageToolsDialogs
{
    /// <summary>
    /// Interaction logic for HomePagePictureToPDFDialogs
    /// </summary>
    public partial class HomePagePictureToPDFDialog : UserControl
    {
        private HomePagePictureToPDFDialogViewModel viewModel;
        public HomePagePictureToPDFDialog()
        {
            InitializeComponent();
            viewModel = this.DataContext as HomePagePictureToPDFDialogViewModel;
        }

        private void Menu_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            menuPop1.IsOpen = true;
        }

        private void listView_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            IList list = listView.SelectedItems;
            var lists = listView.Items;
            System.Data.DataRowView a;
            viewModel.fileNamesView.Clear();
            foreach (var item in list)
            {
                a = (System.Data.DataRowView)item;
                viewModel.fileNamesView.Add(lists.IndexOf(a));
            }
            if (viewModel.fileNamesView.Count > 0)
            {
                viewModel.RemoveIsEnable = "True";
            }
            else
            {
                viewModel.RemoveIsEnable = "False";
            }

        }

        private void RemoveFileMenuItem_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            viewModel.removepicturefile();
        }

        private void OpenFileMenuItem_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            viewModel.openfiledialog();
        }

        private void RadioButton_Click(object sender, System.Windows.RoutedEventArgs e)
        {
            var radiobutton = sender as RadioButton;
            switch (radiobutton.Name.ToString())
            {
                case "NewFilesRadioButtom":
                    {
                        viewModel.pictureToPDFModel.Mode = HomePagePictureToPDFDialogModel.ToPDFFileMode.NewFiles;
                    }
                    break;
                case "OneNewFileNameRadioButtom":
                    {
                        viewModel.pictureToPDFModel.Mode = HomePagePictureToPDFDialogModel.ToPDFFileMode.OneNewFile;
                    }
                    break;
                case "SelectFileNameRadioButton":
                    {
                        viewModel.pictureToPDFModel.Mode = HomePagePictureToPDFDialogModel.ToPDFFileMode.SelectFileName;
                    }
                    break;
                default:
                    break;

            }
        }

        private void DeleteTemplateBtn_Click(object sender, RoutedEventArgs e)
        {
            Button deletetemplatebtn = sender as Button;
            var ls = deletetemplatebtn.DataContext as DataRowView;
            if (ls != null)
            {
                viewModel.removepdffile(viewModel.ImagesDataTable.Rows.IndexOf(ls.Row));
            }
        }
    }
}
