﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ComPDFKit.Import;

namespace PDFSettings
{
    public class HeaderFooterTemplateList: List<BatesHeaderFooterItem>
    {

    }

    public class BatesTemplateList : List<BatesHeaderFooterItem>
    {

    }

    public class BatesHeaderFooterItem
    {
        /// <summary>
        /// 模板名称
        /// </summary>
        public string ItemName  = "";
        /// <summary>
        /// 内容
        /// </summary>
        public contentItem[] TextData = null;
        /// <summary>
        /// 间距
        /// </summary>
        /// 
        public float[] margin = null;
        /// <summary>
        /// 页面范围
        /// </summary>
        public string PageRange  = "0";

        /// <summary>
        /// 起始页
        /// </summary>
        public int StarPagetNumber  = 1;

        /// <summary>
        /// 贝茨码：前缀
        /// </summary>
        public string Prefix  = "";

        /// <summary>
        /// 贝茨码：后缀
        /// </summary>
        public string Suffix = "";
        ///// <summary>
        ///// 贝茨码：起始页
        ///// </summary>
        //public int StartWithPageNum { get; set; }
        /// <summary>
        /// 贝茨码：位数
        /// </summary>
        public int DigitNumber = 1;
        /// <summary>
        /// 页眉页脚：页码格式
        /// </summary>
        public string PageNumberFormat  = "1";
        /// <summary>
        /// 页眉页脚：日期格式
        /// </summary>
        public string DateTimeFormat  = "m/d";

        /// <summary>
        /// 页面范围索引;
        /// 0:全部页面
        /// 1:奇数页
        /// 2;偶数页
        /// 3:自定义页
        /// </summary>
        public int PageRangeIndex = 0;

        public int listIndex = 0;
    }

    public struct contentItem
    {
        public BateHeaderFooter_ContentType textTag;
        public string text;
        public string fontName;
        public float fontSize;
        public byte[] Color;
        public float fontColorR;
        public float fontColorG;
        public float fontColorB;
    }

    public enum BateHeaderFooter_ContentType
    {
        L_Header,
        C_Header,
        R_Header,
        L_Footer,
        C_Footer,
        R_Footer
    }
}
