﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PDFSettings
{
    /// <summary>
    /// 所有工具列表
    /// </summary>
    public class AllPDFToolsList : List<CacheToolItem>
    {

    }

    /// <summary>
    /// 快捷工具列表
    /// </summary>
    public class QuickPDFToolsList : List<CacheToolItem>
    {

    }

    public class CacheToolItem 
    {
        #region 重要属性
        /// <summary>
        /// 是否为新增工具功能
        /// </summary>
        public bool IsNewTool { get; set; }
        /// <summary>
        /// 是否为快捷工具；值0为更多工具、值1为快捷工具
        /// Todo：使用int类型，是因为考虑将来是否会有新需求，除了快捷工具、更多工具外，可能存在以其他布局分类的PDF工具;预留更多的int值以便于缓存数据
        /// </summary>
        public int ToolLayOutType { get; set; }

        /// <summary>
        /// 显示排序号：根据id号递增的方式进行排列顺序
        /// </summary>
        public int ToolTypeId { get; set; }

        /// <summary>
        /// 类型：如普通工具、常用工具、付费工具
        /// </summary>
        public string ToolTypeStr { get; set; }

        /// <summary>
        /// 功能名称：拆分功能、合并功能、转档功能等
        /// Todo：考虑到后续便于迭代PDF工具功能，不能使用int类型进行识别所需的功能，因为int类型会灵活变化，以至于不方便修改增加删除功能；
        /// </summary>
        public string FnTypeStr { get; set; }

        #endregion



    }

}
